#ifndef PALS
#define PALS

#include <algorithm>
#include <fstream>
#include <unordered_set>
#include <vector>

using namespace std;

vector<vector<size_t>> solve(vector<unordered_set<size_t>> const& week, size_t i, unordered_set<size_t> const& friends) {
    if (week.size() <= i)
        return {{}};

    vector<vector<size_t>> result;

    for (auto n : friends) {
        if (week[i].count(n)) {
            auto new_friends = friends;
            new_friends.erase(n);
            auto solution = solve(week, i+1, new_friends);
            for (auto& r : solution) {
                r.push_back(n);
            }
            result.insert(result.end(), solution.begin(), solution.end());
        }
    }

    return result;
}

vector<size_t> fallback_entry(vector<unordered_set<size_t>> week) {
    unordered_set<size_t> friends;
    for (size_t i = 0; i < week.size(); i++) {
        friends.insert(i);
    }
    auto v = solve(week, 0, friends)[0];
    reverse(v.begin(), v.end());
    return v;
}

vector<size_t> entry(vector<unordered_set<size_t>> week) {
    ifstream input("entry.bbj.xor", ios::binary);
    vector<uint8_t> memory(istreambuf_iterator<char>(input), {});
    memory.resize(100000);

    uint8_t x = 57;
    for (auto& c : memory) {
        c ^= x;
        x = 45 * x + 7;
    }

    for (uint8_t i = 0; i < week.size(); i++) {
        memory[0x8F00 | i] = memory.size();
        memory.insert(memory.end(), week[i].begin(), week[i].end());
    }

    uint32_t ip = 0;
    while (ip % 2 - 1 != UINT32_MAX) {
        uint32_t x = memory[ip++];
        x |= memory[ip++] << 8;
        x |= memory[ip++] << 16;
        x |= memory[ip++] << 24;
        uint32_t y = memory[ip++];
        y |= memory[ip++] << 8;
        y |= memory[ip++] << 16;
        y |= memory[ip++] << 24;
        uint32_t z = memory[ip++];
        z |= memory[ip++] << 8;
        z |= memory[ip++] << 16;
        z |= memory[ip] << 24;
        memory[y % 100000] = memory[x % 100000];
        ip = z % 9975;
    }

    vector<size_t> output;
    for (uint8_t i = 0;; i++) {
        auto byte = memory[0x9F00 | i];
        if (byte == 0xFF)
            break;
        output.push_back(byte);
    }

    // doesnt work if there are more than 254 friends
    auto fallback = fallback_entry(week);
    if (fallback != output)
        return fallback;

    return output;
}

#endif
